## growlight 1.2.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(growlight VERSION 1.2.18
  DESCRIPTION "Block device and filesystem manager"
  HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
  LANGUAGES C)
set(CMAKE_C_STANDARD 11)

include(GNUInstallDirs)
include(FeatureSummary)

###################### USER-SELECTABLE OPTIONS ###########################
option(USE_PANDOC "Use pandoc to write man pages" ON)
option(USE_LIBZFS "Use libzfs to manage zpools/ZFS" ON)
#################### END USER-SELECTABLE OPTIONS #########################

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build mode." FORCE)
endif()

add_compile_definitions(FORTIFY_SOURCE=2)
add_compile_options(-Wall -Wextra -W -Wshadow -Wformat -fexceptions)

find_package(PkgConfig REQUIRED)
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)
find_package(Notcurses 2.0.1 CONFIG)
set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)
pkg_check_modules(LIBCAP REQUIRED libcap>=2.24)
pkg_check_modules(LIBCRYPTSETUP REQUIRED libcryptsetup>=2.0.2)
pkg_check_modules(LIBDEVMAPPER REQUIRED devmapper>=1.02.74)
pkg_check_modules(LIBNETTLE REQUIRED nettle>=3.5.1)
pkg_check_modules(LIBPCI REQUIRED libpci>=3.1.9)
pkg_check_modules(LIBPCIACCESS REQUIRED pciaccess>=0.13.1)
pkg_check_modules(LIBREADLINE REQUIRED readline)
pkg_check_modules(LIBUDEV REQUIRED libudev>=175)
pkg_check_modules(LIBZ REQUIRED zlib>=1.2.11)
if(${USE_LIBZFS})
pkg_check_modules(LIBZFS REQUIRED libzfs>=0.8)
endif()

include(CMakePackageConfigHelpers)
configure_file(src/version.h.in include/version.h)

set(COMMON_INCLUDE_DIRS
  "${LIBATASMART_INCLUDE_DIRS}"
  "${LIBBLKID_INCLUDE_DIRS}"
  "${LIBCAP_INCLUDE_DIRS}"
  "${LIBCRYPTSETUP_INCLUDE_DIRS}"
  "${LIBDEVMAPPER_INCLUDE_DIRS}"
  "${LIBNETTLE_INCLUDE_DIRS}"
  "${LIBPCI_INCLUDE_DIRS}"
  "${LIBPCIACCESS_INCLUDE_DIRS}"
  "${LIBUDEV_INCLUDE_DIRS}"
  "${LIBZ_INCLUDE_DIRS}"
  "${LIBZFS_INCLUDE_DIRS}"
  "${Notcurses_INCLUDE_DIRS}"
)

set(COMMON_LIBRARY_DIRS
  "${LIBATASMART_LIBRARY_DIRS}"
  "${LIBBLKID_LIBRARY_DIRS}"
  "${LIBCAP_LIBRARY_DIRS}"
  "${LIBCRYPTSETUP_LIBRARY_DIRS}"
  "${LIBDEVMAPPER_LIBRARY_DIRS}"
  "${LIBNETTLE_LIBRARY_DIRS}"
  "${LIBPCI_LIBRARY_DIRS}"
  "${LIBPCIACCESS_LIBRARY_DIRS}"
  "${LIBUDEV_LIBRARY_DIRS}"
  "${LIBZ_LIBRARY_DIRS}"
  "${LIBZFS_LIBRARY_DIRS}"
  "${Notcurses_LIBRARY_DIRS}"
)

set(COMMON_LIBRARIES
  "${LIBATASMART_LIBRARIES}"
  "${LIBBLKID_LIBRARIES}"
  "${LIBCAP_LIBRARIES}"
  "${LIBCRYPTSETUP_LIBRARIES}"
  "${LIBDEVMAPPER_LIBRARIES}"
  "${LIBNETTLE_LIBRARIES}"
  "${LIBPCI_LIBRARIES}"
  "${LIBPCIACCESS_LIBRARIES}"
  "${LIBREADLINE_LIBRARIES}"
  "${LIBUDEV_LIBRARIES}"
  "${LIBZ_LIBRARIES}"
  "${LIBZFS_LIBRARIES}"
  "${Notcurses_LIBRARIES}"
  Threads::Threads
)

file(GLOB SRCS CONFIGURE_DEPENDS src/*.c)
file(GLOB NCSRCS CONFIGURE_DEPENDS src/notcurses/*.c)
add_executable(growlight ${SRCS} ${NCSRCS})
target_include_directories(growlight
  PRIVATE
    src
    "${PROJECT_BINARY_DIR}/include"
    "${COMMON_INCLUDE_DIRS}"
)
target_compile_definitions(growlight
  PRIVATE
    _GNU_SOURCE _DEFAULT_SOURCE _XOPEN_SOURCE=600
)
target_link_libraries(growlight
  PRIVATE
    "${COMMON_LIBRARIES}"
)
target_link_directories(growlight
  PRIVATE
    "${COMMON_LIBRARY_DIRS}"
)
file(GLOB RLSRCS CONFIGURE_DEPENDS src/readline/*.c)
add_executable(growlight-readline ${SRCS} ${RLSRCS})
target_include_directories(growlight-readline
  PRIVATE
    src
    "${PROJECT_BINARY_DIR}/include"
    "${COMMON_INCLUDE_DIRS}"
)
target_compile_definitions(growlight-readline
  PRIVATE
    _GNU_SOURCE _DEFAULT_SOURCE _XOPEN_SOURCE=600
)
target_link_libraries(growlight-readline
  PRIVATE
    "${COMMON_LIBRARIES}"
)
target_link_directories(growlight-readline
  PRIVATE
    "${COMMON_LIBRARY_DIRS}"
)

# Pandoc documentation (man pages)
if(USE_PANDOC)
  file(GLOB MANSOURCE8 CONFIGURE_DEPENDS doc/man/man8/*.md)
  find_program(PANDOC pandoc)
  if(NOT PANDOC)
    message(FATAL_ERROR "pandoc not found. USE_PANDOC=OFF to disable.")
  else()
    foreach(m ${MANSOURCE8})
      get_filename_component(me ${m} NAME_WLE)
      add_custom_command(
        OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${me}
        DEPENDS ${m}
        COMMAND ${PANDOC}
        ARGS --to man --standalone ${m} > ${CMAKE_CURRENT_BINARY_DIR}/${me}
        COMMENT "Building man page ${me}"
      )
      add_custom_target(${me}.man
        ALL
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${me}
      )
    endforeach()
    foreach(m ${MANSOURCE8})
      get_filename_component(me ${m} NAME_WLE)
      LIST(APPEND MANPAGES8 ${CMAKE_CURRENT_BINARY_DIR}/${me})
    endforeach()
  endif()
endif()

install(TARGETS growlight DESTINATION bin)
install(TARGETS growlight-readline DESTINATION bin)
install(FILES ${MANPAGES8} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man8)

=== debian/changelog ===
growlight (1.2.18-3) unstable; urgency=medium

  * Initial Debian packaging (Closes: #700060)

 -- Nick Black <dankamongmen@gmail.com>  Sat, 07 Nov 2020 12:48:54 -0500

=== debian/control ===
Source: growlight
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends: cmake (>= 3.16),
               debhelper-compat (= 13),
               libatasmart-dev,
               libblkid-dev,
               libcap-dev,
               libcryptsetup-dev,
               libdevmapper-dev,
               libnotcurses-dev (>= 2.0.1),
               libpci-dev,
               libpciaccess-dev,
               libreadline-dev,
               libudev-dev,
               nettle-dev,
               pandoc,
               pkg-config,
               zlib1g-dev
Section: utils
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/growlight
Vcs-Browser: https://salsa.debian.org/debian/growlight
Vcs-Git: https://salsa.debian.org/debian/growlight.git

Package: growlight
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Disk manipulation and system preparation tool
 Growlight can manipulate both real and virtual (mdadm, device-mapper, and LVM)
 disks, find bottlenecks in a storage setup, create partitions and filesystems,
 and prepare fstab files for new installations.

=== debian/tests/control ===
# Dump the block devices with full details using the installed binary
Test-Command: echo "blockdev -v" | growlight-readline
Depends: growlight
Restrictions: allow-stderr, needs-root
Features: test-name=blockdev

## growlight 1.2.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.18
+project(growlight VERSION 1.2.19
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C)
@@ -161,6 +161,6 @@
   endif()
 endif()
 
-install(TARGETS growlight DESTINATION bin)
-install(TARGETS growlight-readline DESTINATION bin)
+install(TARGETS growlight DESTINATION sbin)
+install(TARGETS growlight-readline DESTINATION sbin)
 install(FILES ${MANPAGES8} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man8)

=== debian/changelog ===
growlight (1.2.19-1) unstable; urgency=medium

  * New upstream release: fixes for sigsegv/sigabrt on shutdown, crash
    in readline in growlight-readline, man page expansion

 -- Nick Black <dankamongmen@gmail.com>  Tue, 17 Nov 2020 00:47:31 -0500

## growlight 1.2.20

=== debian/changelog ===
growlight (1.2.20-1) unstable; urgency=medium

  * New upstream release: fixes for irregularly-drawn adapters and
    manual pages

 -- Nick Black <dankamongmen@gmail.com>  Fri, 20 Nov 2020 03:42:08 -0500

## growlight 1.2.21

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.19
+project(growlight VERSION 1.2.21
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C)
@@ -146,7 +146,7 @@
         OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${me}
         DEPENDS ${m}
         COMMAND ${PANDOC}
-        ARGS --to man --standalone ${m} > ${CMAKE_CURRENT_BINARY_DIR}/${me}
+        ARGS --to man --standalone --from markdown-smart ${m} > ${CMAKE_CURRENT_BINARY_DIR}/${me}
         COMMENT "Building man page ${me}"
       )
       add_custom_target(${me}.man
@@ -161,6 +161,7 @@
   endif()
 endif()
 
+install(FILES doc/growlight.jpg DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/growlight)
 install(TARGETS growlight DESTINATION sbin)
 install(TARGETS growlight-readline DESTINATION sbin)
 install(FILES ${MANPAGES8} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man8)

=== debian/changelog ===
growlight (1.2.21-2) unstable; urgency=medium

  * Add doctest-dev to build-depends
  * Comment out breaking "blockdev" autopkgtest for now

 -- Nick Black (Public gmail account) <dankamongmen@gmail.com>  Thu, 26 Nov 2020 20:52:11 -0500

growlight (1.2.21-1) unstable; urgency=medium

  * New upstream release

 -- Nick Black <dankamongmen@gmail.com>  Sun, 22 Nov 2020 05:32:26 -0500

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Maintainer: Nick Black <dankamongmen@gmail.com>
 Build-Depends: cmake (>= 3.16),
                debhelper-compat (= 13),
+               doctest-dev,
                libatasmart-dev,
                libblkid-dev,
                libcap-dev,
@@ -18,7 +19,7 @@
                pkg-config,
                zlib1g-dev
 Section: utils
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Homepage: https://nick-black.com/dankwiki/index.php/growlight
 Vcs-Browser: https://salsa.debian.org/debian/growlight

=== debian/tests/control ===
# Dump the block devices with full details using the installed binary
#Test-Command: echo "blockdev -v" | growlight-readline
#Depends: growlight
#Restrictions: allow-stderr, needs-root
#Features: test-name=blockdev

# The same, running as a regular user (will be lacking most devices)
Test-Command: echo "blockdev -v" | growlight-readline --notroot
Depends: growlight
Restrictions: allow-stderr
Features: test-name=blockdev-nonroot

## growlight 1.2.22

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,25 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.21
+project(growlight VERSION 1.2.22
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
-  LANGUAGES C)
+  LANGUAGES C CXX)
+set(CMAKE_CXX_EXTENSIONS OFF)
 set(CMAKE_C_STANDARD 11)
-
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_VISIBILITY_PRESET hidden)
+
+include(CTest)
 include(GNUInstallDirs)
 include(FeatureSummary)
+include(CMakeDependentOption)
 
 ###################### USER-SELECTABLE OPTIONS ###########################
+# BUILD_TESTING is defined by CTest
+cmake_dependent_option(
+  USE_DOCTEST "Use doctest to build unit tests" ON
+  "${BUILD_TESTING}" OFF
+)
 option(USE_PANDOC "Use pandoc to write man pages" ON)
 option(USE_LIBZFS "Use libzfs to manage zpools/ZFS" ON)
 #################### END USER-SELECTABLE OPTIONS #########################
@@ -23,9 +34,8 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.0.1 CONFIG)
+find_package(Notcurses 2.0.5 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
-feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)
 pkg_check_modules(LIBCAP REQUIRED libcap>=2.24)
@@ -37,9 +47,14 @@
 pkg_check_modules(LIBREADLINE REQUIRED readline)
 pkg_check_modules(LIBUDEV REQUIRED libudev>=175)
 pkg_check_modules(LIBZ REQUIRED zlib>=1.2.11)
+if(${USE_DOCTEST})
+find_package(doctest 2.3.5)
+set_package_properties(doctest PROPERTIES TYPE REQUIRED)
+endif()
 if(${USE_LIBZFS})
 pkg_check_modules(LIBZFS REQUIRED libzfs>=0.8)
 endif()
+feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)
 
 include(CMakePackageConfigHelpers)
 configure_file(src/version.h.in include/version.h)
@@ -132,6 +147,33 @@
   PRIVATE
     "${COMMON_LIBRARY_DIRS}"
 )
+
+if(${USE_DOCTEST})
+file(GLOB TESTSRCS CONFIGURE_DEPENDS tests/*.cpp)
+add_executable(growlight-tester ${SRCS} ${TESTSRCS})
+target_include_directories(growlight-tester
+  PRIVATE
+    src
+    "${PROJECT_BINARY_DIR}/include"
+    "${COMMON_INCLUDE_DIRS}"
+)
+target_compile_definitions(growlight-tester
+  PRIVATE
+    _GNU_SOURCE _DEFAULT_SOURCE _XOPEN_SOURCE=600
+)
+target_link_libraries(growlight-tester
+  PRIVATE
+    "${COMMON_LIBRARIES}"
+)
+target_link_directories(growlight-tester
+  PRIVATE
+    "${COMMON_LIBRARY_DIRS}"
+)
+add_test(
+  NAME growlight-tester
+  COMMAND growlight-tester
+)
+endif()
 
 # Pandoc documentation (man pages)
 if(USE_PANDOC)

=== debian/changelog ===
growlight (1.2.22-1) unstable; urgency=medium

  * New upstream version fixes regressions:
    - GPT checksums are correct once more (broken by move to zlib)
    - Dialog windows get input routed once more (broken by menu additions)
  * Block devices with broken partition tables are displayed now

 -- Nick Black <dankamongmen@gmail.com>  Fri, 27 Nov 2020 12:40:54 -0500

## growlight 1.2.23

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.22
+project(growlight VERSION 1.2.23
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)

## growlight 1.2.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.23
+project(growlight VERSION 1.2.24
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)

=== debian/changelog ===
growlight (1.2.24-1) unstable; urgency=medium

  * New upstream version, fixes refusal to start without /proc/swaps

 -- Nick Black <dankamongmen@gmail.com>  Mon, 07 Dec 2020 12:25:54 -0500

growlight (1.2.23-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Sun, 06 Dec 2020 08:48:53 -0500

## growlight 1.2.25

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.24
+project(growlight VERSION 1.2.25
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)

=== debian/changelog ===
growlight (1.2.25-1) unstable; urgency=medium

  * New upstream version, new partition no longer blows away backup GPT

 -- Nick Black <dankamongmen@gmail.com>  Fri, 18 Dec 2020 23:20:17 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libcap-dev,
                libcryptsetup-dev,
                libdevmapper-dev,
-               libnotcurses-dev (>= 2.0.1),
+               libnotcurses-dev (>= 2.0.5),
                libpci-dev,
                libpciaccess-dev,
                libreadline-dev,

## growlight 1.2.26

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.25
+project(growlight VERSION 1.2.26
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)

=== debian/changelog ===
growlight (1.2.26-1) unstable; urgency=medium

  * New upstream version, update copyright dates

 -- Nick Black <dankamongmen@gmail.com>  Sat, 02 Jan 2021 02:28:51 -0500

## growlight 1.2.27

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.26
+project(growlight VERSION 1.2.27
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,7 +34,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.0.5 CONFIG)
+find_package(Notcurses 2.1.5 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)

=== debian/changelog ===
growlight (1.2.27-1) unstable; urgency=medium

  * New upstream version, dep on notcurses 2.1.5+ for readline
    support, better wide char support on 32-bit.

 -- Nick Black <dankamongmen@gmail.com>  Fri, 15 Jan 2021 19:06:35 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                libcap-dev,
                libcryptsetup-dev,
                libdevmapper-dev,
-               libnotcurses-dev (>= 2.0.5),
+               libnotcurses-dev (>= 2.1.5),
                libpci-dev,
                libpciaccess-dev,
                libreadline-dev,

## growlight 1.2.31

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.27
+project(growlight VERSION 1.2.31
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,7 +34,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.1.5 CONFIG)
+find_package(Notcurses 2.1.8 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)

=== debian/changelog ===
growlight (1.2.31-1) unstable; urgency=medium

  * Sigh, real fix for autopkgtests (and, in general, the
    case where growlight-readline has no controlling terminal)
    (Closes: 982786).

 -- Nick Black <dankamongmen@gmail.com>  Tue, 16 Feb 2021 17:38:42 -0500

growlight (1.2.30-1) unstable; urgency=medium

  * New upstream version, fixes brown-bag segfault on failure
    to initialize UI, as for instance when TERM is undefined.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 15 Feb 2021 22:11:16 -0500

growlight (1.2.28-1) unstable; urgency=medium

  * New upstream version, dep on notcurses 2.1.8+ for
    better readline integration in growlight-readline.

 -- Nick Black <dankamongmen@gmail.com>  Fri, 12 Feb 2021 10:39:31 -0500

=== debian/control ===
Source: growlight
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends:
 cmake (>= 3.16),
 debhelper-compat (= 13),
 doctest-dev,
 libatasmart-dev,
 libblkid-dev,
 libcap-dev,
 libcryptsetup-dev,
 libdevmapper-dev,
 libnotcurses-dev (>= 2.1.8),
 libpci-dev,
 libpciaccess-dev,
 libreadline-dev,
 libudev-dev,
 nettle-dev,
 pandoc,
 pkg-config,
 zlib1g-dev,
Section: utils
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/growlight
Vcs-Browser: https://salsa.debian.org/debian/growlight
Vcs-Git: https://salsa.debian.org/debian/growlight.git

Package: growlight
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Disk manipulation and system preparation tool
 Growlight can manipulate both real and virtual (mdadm, device-mapper, and LVM)
 disks, find bottlenecks in a storage setup, create partitions and filesystems,
 and prepare fstab files for new installations.

=== debian/tests/control ===
# Dump the block devices with full details using the installed binary
Test-Command: echo "blockdev -v" | growlight-readline -v
Depends: growlight
Restrictions: allow-stderr, needs-root
Features: test-name=blockdev

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/archive\/(v\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%growlight-$1.tar.gz%" \
      https://github.com/dankamongmen/growlight/releases (?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
      debian uupdate

## growlight 1.2.34

=== debian/changelog ===
growlight (1.2.34-1) unstable; urgency=medium

  * New upstream, for Notcurses 2.3.9

 -- Nick Black <dankamongmen@gmail.com>  Tue, 13 Jul 2021 08:03:41 -0400

growlight (1.2.33-2) unstable; urgency=medium

  * Upload to unstable now that freeze is upon us

 -- Nick Black <dankamongmen@gmail.com>  Mon, 14 Jun 2021 04:21:26 -0400

growlight (1.2.33-1) experimental; urgency=medium

  * New upstream release

 -- Nick Black <dankamongmen@gmail.com>  Sat, 08 May 2021 18:49:29 -0400

## growlight 1.2.35

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.31
+project(growlight VERSION 1.2.35
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -28,13 +28,13 @@
   set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "Choose the build mode." FORCE)
 endif()
 
-add_compile_definitions(FORTIFY_SOURCE=2)
+add_compile_definitions(_FORTIFY_SOURCE=2)
 add_compile_options(-Wall -Wextra -W -Wshadow -Wformat -fexceptions)
 
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.1.8 CONFIG)
+find_package(Notcurses 2.3.9 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)

=== debian/changelog ===
growlight (1.2.35-1) unstable; urgency=medium

  * New upstream, built for Notcurses 2.3.9

 -- Nick Black <dankamongmen@gmail.com>  Wed, 21 Jul 2021 00:19:29 -0400

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libcap-dev,
  libcryptsetup-dev,
  libdevmapper-dev,
- libnotcurses-dev (>= 2.1.8),
+ libnotcurses-dev (>= 2.2.9),
  libpci-dev,
  libpciaccess-dev,
  libreadline-dev,

## growlight 1.2.37

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.35
+project(growlight VERSION 1.2.37
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,7 +34,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.3.9 CONFIG)
+find_package(Notcurses 2.4.4 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)
@@ -44,7 +44,6 @@
 pkg_check_modules(LIBNETTLE REQUIRED nettle>=3.5.1)
 pkg_check_modules(LIBPCI REQUIRED libpci>=3.1.9)
 pkg_check_modules(LIBPCIACCESS REQUIRED pciaccess>=0.13.1)
-pkg_check_modules(LIBREADLINE REQUIRED readline)
 pkg_check_modules(LIBUDEV REQUIRED libudev>=175)
 pkg_check_modules(LIBZ REQUIRED zlib>=1.2.11)
 if(${USE_DOCTEST})
@@ -98,7 +97,6 @@
   "${LIBNETTLE_LIBRARIES}"
   "${LIBPCI_LIBRARIES}"
   "${LIBPCIACCESS_LIBRARIES}"
-  "${LIBREADLINE_LIBRARIES}"
   "${LIBUDEV_LIBRARIES}"
   "${LIBZ_LIBRARIES}"
   "${LIBZFS_LIBRARIES}"

=== debian/changelog ===
growlight (1.2.37-2) unstable; urgency=medium

  * Export TERM for autopkgtests.

 -- Nick Black <dankamongmen@gmail.com>  Wed, 13 Oct 2021 21:23:14 -0400

growlight (1.2.37-1) unstable; urgency=medium

  * New upstream, fixes growlight-readline crash when redirected.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 12 Oct 2021 04:10:17 -0400

growlight (1.2.36-1) unstable; urgency=medium

  * New upstream, requires Notcurses 2.4.4.
  * Policy version 4.6.0, no changes necessary.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 03 Oct 2021 23:56:55 -0400

=== debian/control ===
--- 
+++ 
@@ -10,17 +10,16 @@
  libcap-dev,
  libcryptsetup-dev,
  libdevmapper-dev,
- libnotcurses-dev (>= 2.2.9),
+ libnotcurses-dev (>= 2.4.4),
  libpci-dev,
  libpciaccess-dev,
- libreadline-dev,
  libudev-dev,
  nettle-dev,
  pandoc,
  pkg-config,
  zlib1g-dev,
 Section: utils
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://nick-black.com/dankwiki/index.php/growlight
 Vcs-Browser: https://salsa.debian.org/debian/growlight

=== debian/tests/control ===
# Dump the block devices with full details using the installed binary
Test-Command: echo "blockdev -v" | TERM=xterm-256color growlight-readline -v
Depends: growlight
Restrictions: allow-stderr, needs-root
Features: test-name=blockdev

## growlight 1.2.38

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.37
+project(growlight VERSION 1.2.38
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,7 +34,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 2.4.4 CONFIG)
+find_package(Notcurses 3.0.0 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)

=== debian/changelog ===
growlight (1.2.38-5) unstable; urgency=medium

  * Autopkgtest environment has no TERM defined; define it.
    Define NOTCURSES_LOGLEVEL in autopkgtests.

 -- Nick Black <dankamongmen@gmail.com>  Sun, 02 Jan 2022 22:03:24 -0500

growlight (1.2.38-3) unstable; urgency=medium

  * Throw in an attempt to get autopkgtests resolved, or at least
    get necessary debugging information.

 -- Nick Black <dankamongmen@gmail.com>  Sat, 01 Jan 2022 11:58:55 -0500

growlight (1.2.38-2) unstable; urgency=medium

  * New upstream, require notcurses > 3.0.0.
  * Restore autopkgtests.

 -- Nick Black <dankamongmen@gmail.com>  Fri, 17 Dec 2021 00:32:54 -0500

growlight (1.2.37-3) unstable; urgency=medium

  * Drop autopkgtests until 1.2.38.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 13 Dec 2021 00:03:40 -0500

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libcap-dev,
  libcryptsetup-dev,
  libdevmapper-dev,
- libnotcurses-dev (>= 2.4.4),
+ libnotcurses-dev (>= 3.0.1),
  libpci-dev,
  libpciaccess-dev,
  libudev-dev,

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/archive\/refs\/tags\/(v\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
      dversionmangle=s/\+dfsg(\.?\d+)?$//,\
      repacksuffix=+dfsg.1, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%growlight-$1.tar.gz%" \
   https://github.com/dankamongmen/growlight/releases (?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
   debian uupdate

## growlight 1.2.39

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.38
+project(growlight VERSION 1.2.39
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,7 +34,7 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 3.0.0 CONFIG)
+find_package(Notcurses 3.0.5 CONFIG)
 set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)
@@ -172,6 +172,11 @@
   COMMAND growlight-tester
 )
 endif()
+
+add_test(
+  NAME blockdev-verbose
+  COMMAND sh -c "echo 'blockdev -v' | ./growlight-readline -v --notroot"
+)
 
 # Pandoc documentation (man pages)
 if(USE_PANDOC)

=== debian/changelog ===
growlight (1.2.39-1) unstable; urgency=medium

  * New upstream release
  * Standards version 4.7.2, no changes needed
  * Bump copyrights

 -- Nick Black <dankamongmen@gmail.com>  Thu, 30 Oct 2025 13:41:14 -0400

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
  pkg-config,
  zlib1g-dev,
 Section: utils
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://nick-black.com/dankwiki/index.php/growlight
 Vcs-Browser: https://salsa.debian.org/debian/growlight

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DUSE_LIBZFS=OFF

=== debian/tests/control ===
--- 
+++ 
@@ -1,3 +1,9 @@
+# Invoke growlight-readline with input redirected from /dev/null
+Test-Command: TERM=xterm-256color NOTCURSES_LOGLEVEL=7 growlight-readline -v < /dev/null
+Depends: growlight
+Restrictions: allow-stderr, needs-root
+Features: test-name=devnull
+
 # Dump the block devices with full details using the installed binary
 Test-Command: echo "blockdev -v" | TERM=xterm-256color growlight-readline -v
 Depends: growlight

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/archive\/refs\/tags/releases\/download/;s/v(\d\S*).tar.gz/v$1\/v$1.tar.gz.asc/" \
      https://github.com/dankamongmen/growlight/tags .*/v(\d\S*)\.tar\.gz \
      debian

## growlight 1.2.40

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.14)
-project(growlight VERSION 1.2.39
+project(growlight VERSION 1.2.40
   DESCRIPTION "Block device and filesystem manager"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/Growlight"
   LANGUAGES C CXX)
@@ -34,8 +34,8 @@
 find_package(PkgConfig REQUIRED)
 find_package(Threads)
 set_package_properties(Threads PROPERTIES TYPE REQUIRED)
-find_package(Notcurses 3.0.5 CONFIG)
-set_package_properties(Notcurses PROPERTIES TYPE REQUIRED)
+find_package(NotcursesCore 3.0.5 CONFIG)
+set_package_properties(NotcursesCore PROPERTIES TYPE REQUIRED)
 pkg_check_modules(LIBATASMART REQUIRED libatasmart>=0.19)
 pkg_check_modules(LIBBLKID REQUIRED blkid>=2.20.1)
 pkg_check_modules(LIBCAP REQUIRED libcap>=2.24)

=== debian/changelog ===
growlight (1.2.40-4) unstable; urgency=medium

  * Standards version 4.7.3, remove explicit Priority field.
  * Remove Rules-Requires-Root directive.
  * Upgrade watchfile to version 5.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 06 Jan 2026 20:05:13 -0500

growlight (1.2.40-3) unstable; urgency=medium

  * Upload to unstable having confirmed cmake tests fix
    (Closes: 1119720).

 -- Nick Black <dankamongmen@gmail.com>  Wed, 05 Nov 2025 17:48:41 -0500

growlight (1.2.40-2) experimental; urgency=medium

  * Cherry-pick 2e74b392 from upstream to avoid running certain
    tests when TERM is not defined.

 -- Nick Black <dankamongmen@gmail.com>  Wed, 05 Nov 2025 12:28:27 -0500

growlight (1.2.40-1) experimental; urgency=medium

  * New upstream release
  * Depend on only libnotcurses-core-dev, not libnotcurses-dev.

 -- Nick Black <dankamongmen@gmail.com>  Wed, 05 Nov 2025 08:49:31 -0500

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,4 @@
 Source: growlight
-Priority: optional
 Maintainer: Nick Black <dankamongmen@gmail.com>
 Build-Depends:
  cmake (>= 3.16),
@@ -10,7 +9,7 @@
  libcap-dev,
  libcryptsetup-dev,
  libdevmapper-dev,
- libnotcurses-dev (>= 3.0.1),
+ libnotcurses-core-dev (>= 3.0.1),
  libpci-dev,
  libpciaccess-dev,
  libudev-dev,
@@ -19,8 +18,7 @@
  pkg-config,
  zlib1g-dev,
 Section: utils
-Standards-Version: 4.7.2
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Homepage: https://nick-black.com/dankwiki/index.php/growlight
 Vcs-Browser: https://salsa.debian.org/debian/growlight
 Vcs-Git: https://salsa.debian.org/debian/growlight.git

=== debian/watch ===
Version: 5

Source: https://github.com/dankamongmen/growlight/tags
Pgp-Sig-Url-Mangle: s/archive\/refs\/tags/releases\/download/;s/v(\d\S*).tar.gz/v$1\/v$1.tar.gz.asc/
